export declare type Specifier = {
    isDefault: boolean;
    name: string;
};
export declare type ImportSpecifier = {
    mainFile: Specifier;
    linkFile?: Specifier;
};
export declare type FileObject = {
    file: string;
    importSpecifiers?: ImportSpecifier[];
    importSource: string;
    isCustomResolveUsed?: boolean;
    isLink?: boolean;
    linkDependencies?: Record<string, any>[];
};
export declare type LinkFile = {
    file: string;
    importSpecifiers: ImportSpecifier[];
};
declare type MissingType = 'files' | 'packages' | 'bits';
export declare type DependenciesResults = {
    files?: FileObject[];
    packages?: {
        [packageName: string]: string;
    };
    unidentifiedPackages?: string[];
    bits?: Record<string, any>;
    error?: Error;
    missing?: {
        [key: MissingType]: string[];
    };
};
export declare type Tree = {
    [filePath: string]: DependenciesResults;
};
export declare type ResolveModulesConfig = {
    modulesDirectories: string[];
    aliases: {
        [key: string]: string;
    };
};
export declare type DependencyTreeParams = {
    baseDir: string;
    consumerPath: string;
    filePaths: string[];
    bindingPrefix: string;
    resolveModulesConfig: ResolveModulesConfig | null | undefined;
    visited: Record<string, any> | null | undefined;
};
export {};
