/// <reference types="node" />
import fs from 'fs-extra';
import Vinyl from 'vinyl';
import { PathOsBased } from '../../../utils/path';
import Source from '../../../scope/models/source';
declare type AbstractVinylProps = {
    cwd: PathOsBased;
    path: PathOsBased;
    base: PathOsBased;
    contents: Buffer;
};
export default class AbstractVinyl extends Vinyl {
    override: boolean;
    verbose: boolean;
    static fromVinyl(vinyl: Vinyl): AbstractVinyl;
    updatePaths({ newBase, newRelative, newCwd }: {
        newBase?: string;
        newRelative?: string;
        newCwd?: string;
    }): void;
    write(writePath?: string, override?: boolean, verbose?: boolean): Promise<string | null | undefined>;
    toReadableString(): {
        relativePath: string;
        content: any;
    };
    static loadFromParsedString(parsedString: any): AbstractVinylProps;
    static loadFromParsedStringArray(arr: Record<string, any>[]): AbstractVinylProps[] | null | undefined;
    toSourceAsLinuxEOL(): Source;
    _getStatIfFileExists(): Promise<fs.Stats | null | undefined>;
}
export declare function _verboseMsg(filePath: string, force: boolean): string;
export {};
