import { ExtensionFileModel, ExtensionFileSerializedModel } from './extension-file';
import { BaseExtensionProps, BaseLoadArgsProps, BaseExtensionOptions, BaseExtensionModel } from './base-extension';
import ExtensionFile from './extension-file';
import { PathOsBased } from '../utils/path';
export declare type EnvType = 'compiler' | 'tester';
declare type EnvExtensionExtraProps = {
    envType: EnvType;
    dynamicPackageDependencies?: Record<string, any> | null | undefined;
};
export declare type EnvExtensionOptions = BaseExtensionOptions;
export declare type EnvLoadArgsProps = BaseLoadArgsProps & EnvExtensionExtraProps & {
    bitJsonPath: PathOsBased;
    files: string[];
};
export declare type EnvExtensionProps = BaseExtensionProps & EnvExtensionExtraProps & {
    files: ExtensionFile[];
};
export declare type EnvExtensionModel = BaseExtensionModel & {
    files?: ExtensionFileModel[];
};
export declare type EnvExtensionSerializedModel = BaseExtensionModel & {
    files?: ExtensionFileSerializedModel[];
};
export {};
