import { PathLinux } from '../utils/path';
export declare type Method = {
    name: string;
    description: string;
    args: [];
    access: 'public' | 'private' | '';
    returns: {};
    modifiers: [];
};
export declare type PropDefaultValue = {
    value: string;
    computed: boolean;
};
export declare type DocProp = {
    name: string;
    description: string;
    required: boolean;
    type: string;
    defaultValue: PropDefaultValue;
};
export declare type Doclet = {
    filePath: PathLinux;
    name: string;
    description: string;
    args?: Array;
    returns?: Record<string, any>;
    access?: string;
    examples?: Array;
    methods?: Method[];
    properties?: DocProp[];
    static?: boolean;
};
