import ComponentWithDependencies from './component-dependencies';
import ComponentVersion from './component-version';
import ComponentObjects from './component-objects';
import Repository from './objects/repository';
import { ManipulateDirItem } from '../consumer/component-ops/manipulate-dir';
export default class VersionDependencies {
    component: ComponentVersion;
    dependencies: ComponentVersion[];
    devDependencies: ComponentVersion[];
    compilerDependencies: ComponentVersion[];
    testerDependencies: ComponentVersion[];
    allDependencies: ComponentVersion[];
    sourceScope: string | null | undefined;
    constructor(component: ComponentVersion, dependencies: ComponentVersion[], devDependencies: ComponentVersion[], compilerDependencies: ComponentVersion[], testerDependencies: ComponentVersion[], sourceScope: string);
    toConsumer(repo: Repository, manipulateDirData: ManipulateDirItem[] | null | undefined): Promise<ComponentWithDependencies>;
    toObjects(repo: Repository, clientVersion: string | null | undefined): Promise<ComponentObjects>;
}
